package com.example.teacher.model;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.persistence.*;
import javax.validation.constraints.*;
import java.util.Date;

@Entity
@Data
@AllArgsConstructor
@NoArgsConstructor
public class Teacher {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    private int id;
    @NotBlank(message = "teacher name should not be blank or null")
    private String name;
    @Min(value = 24, message = "age should not be less than 24")
    @Max(value = 65, message = "age should not be greater than 65")
    private int age;
    @NotBlank(message = "teacher subject should not be blank or null")
    private String subject;
    @JsonFormat(shape=JsonFormat.Shape.STRING, pattern="dd:MM:yyyy")
    @Temporal(TemporalType.DATE)
    private Date dateOfJoining;
    private boolean active;
}
